commit fa98e93d756314f7d0f2a6a432922783c43410ba
Author: jklowden <jklowden>
Date:   Sun Nov 22 21:49:48 2009 +0000

    No error if valid DNS name not in freetds.conf.  Better reporting of server name on login failure.

diff --git a/ChangeLog b/ChangeLog
index b8ada4d..cae9bec 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,8 @@
+Sun Nov 22 16:46:00 EST 2009	JK Lowden <jklowden@freetds.org>
+	* src/tds/config.c src/tds/mem.c
+	- No error if valid DNS name not in freetds.conf. 
+	- Better reporting of server name on login failure. 
+
 Thu Nov 19 09:44:19 CET 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/odbc.c: fix SQLColAttributes for ODBC 2 clients
 
@@ -1892,4 +1897,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2883 2009/11/19 08:45:49 freddy77 Exp $
+$Id: ChangeLog,v 1.2884 2009/11/22 21:49:48 jklowden Exp $
diff --git a/src/tds/config.c b/src/tds/config.c
index 84f9bca..9aacc4e 100644
--- a/src/tds/config.c
+++ b/src/tds/config.c
@@ -76,7 +76,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: config.c,v 1.148 2009/11/19 08:33:36 freddy77 Exp $");
+TDS_RCSID(var, "$Id: config.c,v 1.149 2009/11/22 21:49:49 jklowden Exp $");
 
 static void tds_config_login(TDSCONNECTION * connection, TDSLOGIN * login);
 static void tds_config_env_tdsdump(TDSCONNECTION * connection);
@@ -192,7 +192,8 @@ tds_read_config_info(TDSSOCKET * tds, TDSLOGIN * login, TDSLOCALE * locale)
 		if (!tds_read_interfaces(tds_dstr_cstr(&login->server_name), connection)) {
 			tdsdump_log(TDS_DBG_INFO1, "Failed to find [%s] in configuration files; trying '%s' instead.\n", 
 						   tds_dstr_cstr(&login->server_name), tds_dstr_cstr(&connection->server_name));
-			tdserror(tds->tds_ctx, tds, TDSEINTF, 0);
+			if (tds_dstr_isempty(&connection->ip_addr))
+				tdserror(tds->tds_ctx, tds, TDSEINTF, 0);
 		}
 	}
 
@@ -205,6 +206,9 @@ tds_read_config_info(TDSSOCKET * tds, TDSLOGIN * login, TDSLOCALE * locale)
 	if (opened) {
 		tdsdump_log(TDS_DBG_INFO1, "Final connection parameters:\n");
 		tdsdump_log(TDS_DBG_INFO1, "\t%20s = %s\n", "server_name", tds_dstr_cstr(&connection->server_name));
+		tdsdump_log(TDS_DBG_INFO1, "\t%20s = %s\n", "server_host_name", tds_dstr_cstr(&connection->server_host_name));
+		tdsdump_log(TDS_DBG_INFO1, "\t%20s = %s\n", "ip_addr", tds_dstr_cstr(&connection->ip_addr));
+		tdsdump_log(TDS_DBG_INFO1, "\t%20s = %s\n", "instance_name", tds_dstr_cstr(&connection->instance_name));
 		tdsdump_log(TDS_DBG_INFO1, "\t%20s = %d\n", "port", connection->port);
 		tdsdump_log(TDS_DBG_INFO1, "\t%20s = %d\n", "major_version", TDS_MAJOR(connection));
 		tdsdump_log(TDS_DBG_INFO1, "\t%20s = %d\n", "minor_version", TDS_MINOR(connection));
@@ -213,6 +217,7 @@ tds_read_config_info(TDSSOCKET * tds, TDSLOGIN * login, TDSLOCALE * locale)
 		tdsdump_log(TDS_DBG_INFO1, "\t%20s = %s\n", "server_charset", tds_dstr_cstr(&connection->server_charset));
 		tdsdump_log(TDS_DBG_INFO1, "\t%20s = %d\n", "connect_timeout", connection->connect_timeout);
 		tdsdump_log(TDS_DBG_INFO1, "\t%20s = %s\n", "client_host_name", tds_dstr_cstr(&connection->client_host_name));
+		tdsdump_log(TDS_DBG_INFO1, "\t%20s = %s\n", "client_charset", tds_dstr_cstr(&connection->client_charset));
 		tdsdump_log(TDS_DBG_INFO1, "\t%20s = %s\n", "app_name", tds_dstr_cstr(&connection->app_name));
 		tdsdump_log(TDS_DBG_INFO1, "\t%20s = %s\n", "user_name", tds_dstr_cstr(&connection->user_name));
 		/* tdsdump_log(TDS_DBG_PASSWD, "\t%20s = %s\n", "password", tds_dstr_cstr(&connection->password)); 
@@ -224,9 +229,6 @@ tds_read_config_info(TDSSOCKET * tds, TDSLOGIN * login, TDSLOCALE * locale)
 		tdsdump_log(TDS_DBG_INFO1, "\t%20s = %d\n", "query_timeout", connection->query_timeout);
 		/* tdsdump_log(TDS_DBG_INFO1, "\t%20s = %s\n", "capabilities", tds_dstr_cstr(&connection->capabilities)); 
 			(not null terminated) */
-		tdsdump_log(TDS_DBG_INFO1, "\t%20s = %s\n", "client_charset", tds_dstr_cstr(&connection->client_charset));
-		tdsdump_log(TDS_DBG_INFO1, "\t%20s = %s\n", "ip_addr", tds_dstr_cstr(&connection->ip_addr));
-		tdsdump_log(TDS_DBG_INFO1, "\t%20s = %s\n", "instance_name", tds_dstr_cstr(&connection->instance_name));
 		tdsdump_log(TDS_DBG_INFO1, "\t%20s = %s\n", "database", tds_dstr_cstr(&connection->database));
 		tdsdump_log(TDS_DBG_INFO1, "\t%20s = %s\n", "dump_file", tds_dstr_cstr(&connection->dump_file));
 		tdsdump_log(TDS_DBG_INFO1, "\t%20s = %x\n", "debug_flags", connection->debug_flags);
@@ -576,8 +578,9 @@ tds_parse_conf_section(const char *option, const char *value, void *param)
 static void
 tds_config_login(TDSCONNECTION * connection, TDSLOGIN * login)
 {
-	if (!tds_dstr_isempty(&login->server_name) && tds_dstr_isempty(&connection->server_name)) {
-		tds_dstr_dup(&connection->server_name, &login->server_name);
+	if (!tds_dstr_isempty(&login->server_name)) {
+		if (1 || tds_dstr_isempty(&connection->server_name)) 
+			tds_dstr_dup(&connection->server_name, &login->server_name);
 	}
 	if (login->tds_version)
 		connection->tds_version = login->tds_version;
diff --git a/src/tds/mem.c b/src/tds/mem.c
index 3616d78..81f0eb5 100644
--- a/src/tds/mem.c
+++ b/src/tds/mem.c
@@ -41,7 +41,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: mem.c,v 1.191 2009/08/25 14:25:35 freddy77 Exp $");
+TDS_RCSID(var, "$Id: mem.c,v 1.192 2009/11/22 21:49:49 jklowden Exp $");
 
 static void tds_free_env(TDSSOCKET * tds);
 static void tds_free_compute_results(TDSSOCKET * tds);
@@ -998,15 +998,15 @@ tds_alloc_login(void)
 	if ((s=getenv("TDSQUERY")) != NULL)
 		server_name = s;
 
-	if (!tds_dstr_copy(&tds_login->server_name, server_name))
-		goto Cleanup;
+	if (!tds_dstr_copy(&tds_login->server_name, server_name)) {
+		free(tds_login);
+		return NULL;
+	}
+
 	memcpy(tds_login->capabilities, defaultcaps, TDS_MAX_CAPABILITY);
 
+	Cleanup:
 	return tds_login;
-
-      Cleanup:
-	free(tds_login);
-	return NULL;
 }
 
 void

